function C = fixationRecalibration(F, stimCoords)

    T = fminsearch(@avgDistanceToClosestFixation, eye(2));
    C = T*F;
    
    
    function avgDistance = avgDistanceToClosestFixation(transformation)
        
        coords = transformation*F; %transform coordinates
        distClosest = zeros(1, size(coords,2));
        
        for fixNum = 1:size(coords, 2)
            dist = zeros(1, size(stimCoords,2));
            
            for stimNum = 1:size(stimCoords,2)
                dist(stimNum) = norm(coords(:,fixNum)-stimCoords(:,stimNum));
            end
            
            distClosest(fixNum) = min(dist);
        end
        
        avgDistance = mean(distClosest);
        
    end

end