function showCalibArrows(Fa, Ca, cfg)

%credit to "bdecaf" of Stack Overflow:
%  http://stackoverflow.com/questions/11499370/how-to-plot-arrow-onto-a-fig
%  ure-in-matlab

%% get info specific to the axes you plan to plot into

set(gcf,'Units','normalized')
set(gca,'Units','normalized')

ax = axis;
ap = get(gca,'Position');

%% add arrows

for i = 1:length(Ca)
    
    %make sure the arrow isn't out of bounds, which it could be if there
    %are fixations off-screen
    if Fa(1,i) < 0
        fxOne = 0;
    elseif Fa(1,i) > cfg.screenwidthpix
        fxOne = cfg.screenwidthpix;
    else
        fxOne = Fa(1,i);
    end
    
    if Ca(1,i) < 0
        cxOne = 0;
    elseif Ca(1,i) > cfg.screenwidthpix
        cxOne = cfg.screenwidthpix;
    else
        cxOne = Ca(1,i);
    end
    
    if Fa(2,i) < 0
        fxTwo = cfg.screenheightpix;
    elseif Fa(2,i) > cfg.screenheightpix
        fxTwo = 0;
    else
        fxTwo = abs(Fa(2,i)-cfg.screenheightpix);
    end
    
    if Ca(2,i) < 0
        cxTwo = cfg.screenheightpix;
    elseif Ca(2,i) > cfg.screenheightpix
        cxTwo = 0;
    else
        cxTwo = abs(Ca(2,i)-cfg.screenheightpix);
    end
    
    xo = [fxOne, cxOne];
    yo = [fxTwo, cxTwo];
    xp = (xo-ax(1))/(ax(2)-ax(1))*ap(3)+ap(1);
    yp = (yo-ax(3))/(ax(4)-ax(3))*ap(4)+ap(2);
    annotation('arrow',xp, yp, 'Color', 'r', 'HeadStyle', 'vback3', ...
        'HeadLength', 5, 'HeadWidth', 5);
end