function writeProcessedFile(eyeData, matname, cfg, flname, DATA)

%DATA.trials(i,:) = [trialID, repeat(1***)/new(2***)/quad(**X*), block, Tloc, 
%                    Tid, Torient (2L 4R), keyPress, Acc, RT]


if nargin == 4
    DATA = 0;
elseif nargin == 3
    DATA = 0;
    width = input('Screen width (pixels):\n');
    height = input('Screen height (pixels):\n');
else
    width = DATA.el.width;
    height = DATA.el.height;
end

writefilename = strcat(matname, '_processed.csv');


%)))*** GATHER DATA ***(((


%time til first fixation on target etc
cumT_firstTargFix = repmat(-10,(size(eyeData,2)),1);
cumT_firstNoisyFix = repmat(-10,(size(eyeData,2)),1);
cumT_firstStableFix = repmat(-10,(size(eyeData,2)),1);
collectedT = zeros(size(eyeData,2),1);
collectedN = zeros(size(eyeData,2),1);
collectedS = zeros(size(eyeData,2),1);
countT = zeros(size(eyeData,2),1);
countN = zeros(size(eyeData,2),1);
countS = zeros(size(eyeData,2),1);
totTargDur = zeros(size(eyeData,2),1);
totNoisyDur = zeros(size(eyeData,2),1);
totStableDur = zeros(size(eyeData,2),1);

cumT_firstTargFixNear = repmat(-10,(size(eyeData,2)),1);
cumT_firstNoisyFixNear = repmat(-10,(size(eyeData,2)),1);
cumT_firstStableFixNear = repmat(-10,(size(eyeData,2)),1);
collectedTNear = zeros(size(eyeData,2),1);
collectedNNear = zeros(size(eyeData,2),1);
collectedSNear = zeros(size(eyeData,2),1);
countTNear = zeros(size(eyeData,2),1);
countNNear = zeros(size(eyeData,2),1);
countSNear = zeros(size(eyeData,2),1);
totTargDurNear = zeros(size(eyeData,2),1);
totNoisyDurNear = zeros(size(eyeData,2),1);
totStableDurNear = zeros(size(eyeData,2),1);


for i = 1:size(eyeData,2)
%     fprintf('process file: trial %i\n', i);

    if i == cfg.debugTrial
        fprintf('\ndebug at line 1036 for chosen file writing\n');
    end
    
    
    if ~isfield(eyeData(i), 'fixdur')
        fprintf('\n[PROCESSED]No fix duration for trial %i. Use first fix = %i. Skipping...\n', i, cfg.firstfix);
    else

        
        firstfixloc(i) = eyeData(i).ROI(1);
        firstfixdur(i) = eyeData(i).fixdur(1);
        lastfixloc(i) = eyeData(i).ROI(length(eyeData(i).x));
        lastfixdur(i) = eyeData(i).fixdur(length(eyeData(i).x));
        
        firstfixlocnear(i) = eyeData(i).nearestStim(1);
        firstfixdurnear(i) = firstfixdur(i);
        lastfixlocnear(i) = eyeData(i).nearestStim(length(eyeData(i).x));
        lastfixdurnear(i) = lastfixdur(i);
        
        
        
        %run regressions on (1) negatie cumulative viewing time (i.e. zero 
        %is when the decision is made) and fixation duration and the
        %number of noisy/stable distractors within a given region, (2)
        %cumulative viewing time and the distance to the nearest
        %noisy/stable distractors, (3)
    
        
        
        for fixno = 1:length(eyeData(i).x)
            
            %------------------------
            %determine time until first fixation on the target
            if eyeData(i).ROI(fixno) == 1 && collectedT(i) == 0 %target?
                cumT_firstTargFix(i) = eyeData(i).tstamp(fixno);
                collectedT(i) = 1;
            end
            
            if eyeData(i).ROI(fixno) == 2 && collectedN(i) == 0 %noisy distractor
                cumT_firstNoisyFix(i) = eyeData(i).tstamp(fixno);
                collectedN(i) = 1;
            end
            
            if eyeData(i).ROI(fixno) == 3 && collectedS(i) == 0 %stable distractor
                cumT_firstStableFix(i) = eyeData(i).tstamp(fixno);
                collectedS(i) = 1;
            end
            
            % - %
            
            if eyeData(i).nearestStim(fixno) == 1 && collectedTNear(i) == 0 %target?
                cumT_firstTargFixNear(i) = eyeData(i).tstamp(fixno);
                collectedTNear(i) = 1;
            end
            
            if eyeData(i).nearestStim(fixno) == 2 && collectedNNear(i) == 0 %noisy distractor
                cumT_firstNoisyFixNear(i) = eyeData(i).tstamp(fixno);
                collectedNNear(i) = 1;
            end
            
            if eyeData(i).nearestStim(fixno) == 3 && collectedSNear(i) == 0 %stable distractor
                cumT_firstStableFixNear(i) = eyeData(i).tstamp(fixno);
                collectedSNear(i) = 1;
            end
            
            %------------------------
            %total gaze time & Nfixations
            if eyeData(i).ROI(fixno) == 1
                totTargDur(i) = totTargDur(i) + eyeData(i).fixdur(fixno);
                countT(i) = countT(i) + 1;
            end
            
            if eyeData(i).ROI(fixno) == 2
                totNoisyDur(i) = totNoisyDur(i) + eyeData(i).fixdur(fixno);
                countN(i) = countN(i) + 1;
            end
            
            if eyeData(i).ROI(fixno) == 3
                totStableDur(i) = totStableDur(i) + eyeData(i).fixdur(fixno);
                countS(i) = countS(i) + 1;
            end
            
            
            % - %
            
            if eyeData(i).nearestStim(fixno) == 1
                totTargDurNear(i) = totTargDurNear(i) + eyeData(i).fixdur(fixno);
                countTNear(i) = countTNear(i) + 1;
            end
            
            if eyeData(i).nearestStim(fixno) == 2
                totNoisyDurNear(i) = totNoisyDurNear(i) + eyeData(i).fixdur(fixno);
                countNNear(i) = countNNear(i) + 1;
            end
            
            if eyeData(i).nearestStim(fixno) == 3
                totStableDurNear(i) = totStableDurNear(i) + eyeData(i).fixdur(fixno);
                countSNear(i) = countSNear(i) + 1;
            end
            
            
            %-----------------
            %distance from target/distance moved
            eyeData(i).distFromTarg(fixno) = sqrt((eyeData(i).x(fixno) - ...
                eyeData(i).targetlocX)^2 + (eyeData(i).y(fixno) - ...
                eyeData(i).targetlocY)^2);
            
            if fixno > 1 %skip first
                %calculate absolute distance moved
                eyeData(i).distMoved(fixno-1) = sqrt((eyeData(i).x(fixno-1) + ...
                    eyeData(i).x(fixno))^2 + (eyeData(i).y(fixno-1) + ...
                    eyeData(i).y(fixno))^2);
            
                %relative distance moved (toward[1] or away[-1])
                if eyeData(i).distFromTarg(fixno) < eyeData(i).distFromTarg(fixno-1)
                    eyeData(i).saccDirection(fixno-1) = 1;
                elseif eyeData(i).distFromTarg(fixno) > eyeData(i).distFromTarg(fixno-1)
                    eyeData(i).saccDirection(fixno-1) = -1;
                elseif eyeData(i).distFromTarg(fixno) == eyeData(i).distFromTarg(fixno-1)
                    eyeData(i).saccDirection(fixno-1) = 0;
                end
                
            end
            
        end
        
        if ~isfield(eyeData(i), 'saccDirection')
            eyeData(i).saccDirection = -10;
        end
        
        if ~isfield(eyeData(i), 'distFromTarg')
            eyeData(i).distFromTarg = -10;
        end
            
        %------------------------
        %ave fixation duration

        if countT(i) == 0
            aveTdur(i) = -10;
        else
            aveTdur(i) = totTargDur(i)/countT(i);
        end
        
        if countN(i) == 0
            aveNdur(i) = -10;
        else
            aveNdur(i) = totNoisyDur(i)/countN(i);
        end
        
        if countS(i) == 0
            aveSdur(i) = -10;
        else
            aveSdur(i) = totStableDur(i)/countS(i);
        end
        
        
        % - %
        
        if countTNear(i) == 0
            aveTdurNear(i) = -10;
        else
            aveTdurNear(i) = totTargDurNear(i)/countTNear(i);
        end
        
        if countNNear(i) == 0
            aveNdurNear(i) = -10;
        else
            aveNdurNear(i) = totNoisyDurNear(i)/countNNear(i);
        end
        
        if countSNear(i) == 0
            aveSdurNear(i) = -10;
        else
            aveSdurNear(i) = totStableDurNear(i)/countSNear(i);
        end
        
        

        %------------------------
        %number of movements toward target
        nMoveToward(i) = sum(eyeData(i).saccDirection==1);
        nMoveAway(i) = sum(eyeData(i).saccDirection==-1);
        
        
        %------------------------
        %ave dist from target t1, t2, t3, t4 and t5
        trialDur = eyeData(i).tstamp(length(eyeData(i).tstamp)); %get trial duration
        trialSplit = [0:trialDur/5:trialDur];
        
        for z = 1:length(trialSplit)-1
           
           
           chck=0; %break check, allows for the gathering of just one more
           %fixation position, not strictly necessary
           countr=1;
           
           for y = 2:length(eyeData(i).tstamp)+1
               
               if eyeData(i).tstamp(y-1) < trialSplit(z+1) && ...
                       eyeData(i).tstamp(y-1) > trialSplit(z) && chck == 0
                   
                   tempdist(countr) = eyeData(i).distFromTarg(y-1);
                   countr = countr+1;
                   
               elseif eyeData(i).tstamp(y-1) > trialSplit(z) && chck == 0
                   
                   tempdist(countr) = eyeData(i).distFromTarg(y-1);
                   chck = 1; countr = countr+1;
                   break
               end
               
           end
           
           if ~exist('tempdist', 'var')
               aveDist(i, z) = -10;
           else
               aveDist(i, z) = mean(tempdist);
           end
           clear tempdist;
           
        end
        
        
        
    end
    
    
end %i

save(flname, 'eyeData');


%)))*** WRITE TO FILE ***(((


fid = fopen(writefilename, 'w');

hdr = {'exclude', 'pno', 'age', 'sex', 'hand', 'dist_from_screen', 'stimsize_degrees',...
    'trialID', 'block', 'patternID', 'repeat1_new0', ...
    'targetQuadrant', 'targetPos', 'orientation_-1L_+1R', 'response', 'correct', ...
    'decision_RT', 'firstFixLocation', 'firstFixDuration', 'lastFixLocation', ...
    'lastFixDuration', 'cumulativeTime_firstTargetFixation', ...
    'cumulativeTime_firstNoisyFixation', 'cumulativeTime_firstStableFixation', ...
    'totalTargetFixDuration', 'totalNoisyFixDuration', 'totalStableFixDuration', ...
    'Nfix_Target', 'Nfix_Noisy', 'Nfix_Stable', 'aveFixDur_Target', ...
    'aveFixDur_Noisy', 'aveFixDur_Stable', 'aveDistFromTarget_t1', ...
    'aveDistFromTarget_t2', 'aveDistFromTarget_t3', 'aveDistFromTarget_t4',...
    'aveDistFromTarget_t5','NmoveTowardTarget', 'NmoveAwayTarget', 'SpanSizeDegrees', ...
    'Epoch'};

for h = 1:length(hdr)
    fprintf(fid, '%s,', hdr{h});
end

if cfg.valpatt == 1
    fprintf(fid, '%s,', 'validPattern_1yes');
end


fprintf(fid, '\n'); %new line
pno = str2double(matname(11:end)); %get pno from file

%ensure pno is numeric
if ~isnumeric(pno)
    pno = str2double(pno);
end

for i = 1:size(eyeData,2)
    
    exclude = eyeData(i).exclude;
    
    fprintf(fid, '%i,', exclude, pno, DATA.age);
    fprintf(fid, '%s,', DATA.sex, DATA.hand);
    fprintf(fid, '%1.3f,', DATA.scrdist_mm, DATA.stimsize_deg, i, eyeData(i).block,...
        eyeData(i).patternID, eyeData(i).repeat, eyeData(i).quadrant, ...
        eyeData(i).targetpos, eyeData(i).orient, eyeData(i).resp, ...
        eyeData(i).acc, ...
        DATA.trials(i,9), firstfixloc(i), firstfixdur(i), lastfixloc(i), ...
        lastfixdurnear(i), cumT_firstTargFix(i), cumT_firstNoisyFix(i), ...
        cumT_firstStableFix(i), totTargDur(i), totNoisyDur(i), totStableDur(i), ...
        countT(i), countN(i), countS(i), aveTdur(i), aveNdur(i), aveSdur(i), ...
        aveDist(i, 1), aveDist(i, 2), aveDist(i, 3), aveDist(i, 4), aveDist(i, 5),...
        nMoveToward(i), nMoveAway(i), eyeData(1).visspandeg, eyeData(i).epoch);
    
    if cfg.valpatt == 1
        fprintf(fid, '%i,', eyeData(i).validPattern);
    end
   
    
    fprintf(fid, '\n');

end

fclose(fid);


%** MOVE **
if cfg.movefile == 1
    %move csv file
    if ~exist('datafiles/Processed', 'dir')
        mkdir('datafiles/Processed');
    end

    dest = strcat(cd, '/datafiles/Processed');
    movefile(writefilename, dest, 'f');
end



%)))*** WRITE TO FILE -- NEAREST FIX ***(((


nearFilename = strcat(writefilename(1:end-4), '_near.csv');

fid = fopen(nearFilename, 'w');

hdr = {'exclude', 'pno', 'age', 'sex', 'hand', 'dist_from_screen', 'stimsize_degrees',...
    'trialID', 'block', 'patternID', 'repeat1_new0', ...
    'targetQuadrant', 'targetPos', 'orientation_-1L_+1R', 'response', 'correct', ...
    'decision_RT', 'firstFixLoc_Nearest', 'firstFixDur', 'lastFixLoc_Nearest', ...
    'lastFixDura', 'cumulativeTime_firstNearTargetFix', ...
    'cumulativeTime_firstNearNoisyFix', 'cumulativeTime_firstNearStableFix', ...
    'totalNearTargetFixDur', 'totalNearNoisyFixDur', 'totalNearStableFixDur', ...
    'Nfix_TargetNear', 'Nfix_NoisyNear', 'Nfix_StableNear', 'aveFixDur_TargetNear', ...
    'aveFixDur_NoisyNear', 'aveFixDur_StableNear', 'aveDistFromTarget_t1', ...
    'aveDistFromTarget_t2', 'aveDistFromTarget_t3', 'aveDistFromTarget_t4',...
    'aveDistFromTarget_t5','NmoveTowardTarget', 'NmoveAwayTarget', 'SpanSizeDegrees', ...
    'Epoch'};

for h = 1:length(hdr)
    fprintf(fid, '%s,', hdr{h});
end

if cfg.valpatt == 1
    fprintf(fid, '%s,', 'validPattern_1yes');
end

fprintf(fid, '\n'); %new line
pno = str2double(matname(11:end)); %get pno from file

%ensure pno is numeric
if ~isnumeric(pno)
    pno = str2double(pno);
end

for i = 1:size(eyeData,2)
    
    exclude = eyeData(i).exclude;
    
    fprintf(fid, '%i,', exclude, pno, DATA.age);
    fprintf(fid, '%s,', DATA.sex, DATA.hand);
    fprintf(fid, '%1.3f,', DATA.scrdist_mm, DATA.stimsize_deg, i, eyeData(i).block,...
        eyeData(i).patternID, eyeData(i).repeat, eyeData(i).quadrant, ...
        eyeData(i).targetpos, eyeData(i).orient, eyeData(i).resp, ...
        eyeData(i).acc, ...
        DATA.trials(i,9), firstfixlocnear(i), firstfixdurnear(i), lastfixlocnear(i), ...
        lastfixdurnear(i), cumT_firstTargFixNear(i), cumT_firstNoisyFixNear(i), ...
        cumT_firstStableFixNear(i), totTargDurNear(i), totNoisyDurNear(i), totStableDurNear(i), ...
        countTNear(i), countNNear(i), countSNear(i), aveTdurNear(i), aveNdurNear(i), aveSdurNear(i), ...
        aveDist(i, 1), aveDist(i, 2), aveDist(i, 3), aveDist(i, 4), aveDist(i, 5),...
        nMoveToward(i), nMoveAway(i), eyeData(1).visspandeg, eyeData(i).epoch);
    
    if cfg.valpatt == 1
        fprintf(fid, '%i,', eyeData(i).validPattern);
    end
    
    fprintf(fid, '\n');

end

fclose(fid);


%** MOVE **
if cfg.movefile == 1
    %move csv file
    if ~exist('datafiles/Processed_near', 'dir')
        mkdir('datafiles/Processed_near');
    end

    dest = strcat(cd, '/5.datafiles/Processed_near');
    movefile(nearFilename, dest, 'f');
    
    
    
    if ~exist('processed_mat', 'dir')
        mkdir('processed_mat', 'dir');
    end

    dest2 = strcat(cd, '/4.processed_mat');
    movefile(flname, dest2, 'f');
    
end

end

